/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  25 Mar 2007 4:41:07 pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
#include "ColourChooser.h"
#include "AboutBox.h"

#include <iostream>
#include <sstream>
#include <iomanip>

using namespace std;
//[/Headers]

#include "Window.h"



//==============================================================================
Window::Window ()
    : drawingPanel (0),
      prevFrame (0),
      currentFrame (0),
      nextFrame (0),
      store (0),
      play (0),
      lengthLabel (0),
      length (0),
      colour1 (0),
      colour2 (0),
      colour3 (0),
      colour4 (0),
      coloursLabel (0)
{
    addAndMakeVisible (drawingPanel = new DrawingPanel());
    drawingPanel->setName (T("drawingPanel"));

    addAndMakeVisible (prevFrame = new TextButton (T("prevFrame")));
    prevFrame->setButtonText (T("<"));
    prevFrame->setConnectedEdges (Button::ConnectedOnRight);
    prevFrame->addButtonListener (this);
    prevFrame->setColour (TextButton::buttonColourId, Colours::lightblue);

    addAndMakeVisible (currentFrame = new TextEditor (T("currentFrame")));
    currentFrame->setMultiLine (false);
    currentFrame->setReturnKeyStartsNewLine (false);
    currentFrame->setReadOnly (false);
    currentFrame->setScrollbarsShown (true);
    currentFrame->setCaretVisible (true);
    currentFrame->setPopupMenuEnabled (true);
    currentFrame->setText (T("0.00"));

    addAndMakeVisible (nextFrame = new TextButton (T("nextFrame")));
    nextFrame->setButtonText (T(">"));
    nextFrame->setConnectedEdges (Button::ConnectedOnLeft);
    nextFrame->addButtonListener (this);
    nextFrame->setColour (TextButton::buttonColourId, Colours::lightblue);

    addAndMakeVisible (store = new TextButton (T("store")));
    store->setButtonText (T("Store"));
    store->addButtonListener (this);
    store->setColour (TextButton::buttonColourId, Colour (0xffff2e2e));
    store->setColour (TextButton::buttonOnColourId, Colours::red);

    addAndMakeVisible (play = new TextButton (T("play")));
    play->setButtonText (T("Play"));
    play->addButtonListener (this);
    play->setColour (TextButton::buttonColourId, Colour (0xff20941d));
    play->setColour (TextButton::buttonOnColourId, Colour (0xff2fb200));

    addAndMakeVisible (lengthLabel = new Label (T("lengthLabel"),
                                                T("Length (seconds):")));
    lengthLabel->setFont (Font (15.0000f, Font::plain));
    lengthLabel->setJustificationType (Justification::centredLeft);
    lengthLabel->setEditable (false, false, false);
    lengthLabel->setColour (Label::backgroundColourId, Colour (0x0));
    lengthLabel->setColour (Label::textColourId, Colours::black);
    lengthLabel->setColour (Label::outlineColourId, Colour (0x0));
    lengthLabel->setColour (TextEditor::textColourId, Colours::black);
    lengthLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));

    addAndMakeVisible (length = new TextEditor (T("length")));
    length->setMultiLine (false);
    length->setReturnKeyStartsNewLine (false);
    length->setReadOnly (false);
    length->setScrollbarsShown (true);
    length->setCaretVisible (true);
    length->setPopupMenuEnabled (true);
    length->setText (T("180"));

    addAndMakeVisible (colour1 = new TextButton (T("colour1")));
    colour1->setButtonText (T("1"));
    colour1->setConnectedEdges (Button::ConnectedOnRight);
    colour1->addButtonListener (this);
    colour1->setColour (TextButton::buttonColourId, Colours::lightblue);

    addAndMakeVisible (colour2 = new TextButton (T("colour2")));
    colour2->setButtonText (T("2"));
    colour2->setConnectedEdges (Button::ConnectedOnLeft | Button::ConnectedOnRight);
    colour2->addButtonListener (this);
    colour2->setColour (TextButton::buttonColourId, Colours::lightblue);

    addAndMakeVisible (colour3 = new TextButton (T("colour3")));
    colour3->setButtonText (T("3"));
    colour3->setConnectedEdges (Button::ConnectedOnLeft | Button::ConnectedOnRight);
    colour3->addButtonListener (this);
    colour3->setColour (TextButton::buttonColourId, Colours::lightblue);

    addAndMakeVisible (colour4 = new TextButton (T("colour4")));
    colour4->setButtonText (T("4"));
    colour4->setConnectedEdges (Button::ConnectedOnLeft);
    colour4->addButtonListener (this);
    colour4->setColour (TextButton::buttonColourId, Colours::lightblue);

    addAndMakeVisible (coloursLabel = new Label (T("coloursLabel"),
                                                 T("Colours:")));
    coloursLabel->setFont (Font (15.0000f, Font::plain));
    coloursLabel->setJustificationType (Justification::centredLeft);
    coloursLabel->setEditable (false, false, false);
    coloursLabel->setColour (Label::backgroundColourId, Colour (0x0));
    coloursLabel->setColour (Label::textColourId, Colours::black);
    coloursLabel->setColour (Label::outlineColourId, Colour (0x0));
    coloursLabel->setColour (TextEditor::textColourId, Colours::black);
    coloursLabel->setColour (TextEditor::backgroundColourId, Colour (0x0));

    setSize (800, 620);

    //[Constructor] You can add your own custom stuff here..

	fileLoader = new FileLoader(this);

	for(int i=0;i<4;++i)
		lastSelectedPolys[i] = true;

	currentTime = 0.0f;
	currentLength = 180.0f;

	nextFrame->setRepeatSpeed(250, 100);
	prevFrame->setRepeatSpeed(250, 100);
	currentFrame->addListener(this);
	length->addListener(this);
	drawingPanel->addChangeListener(this);
    //[/Constructor]
}

Window::~Window()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
	delete fileLoader;
    //[/Destructor_pre]

    deleteAndZero (drawingPanel);
    deleteAndZero (prevFrame);
    deleteAndZero (currentFrame);
    deleteAndZero (nextFrame);
    deleteAndZero (store);
    deleteAndZero (play);
    deleteAndZero (lengthLabel);
    deleteAndZero (length);
    deleteAndZero (colour1);
    deleteAndZero (colour2);
    deleteAndZero (colour3);
    deleteAndZero (colour4);
    deleteAndZero (coloursLabel);

    //[Destructor]. You can add your own custom destruction code here..
    //[/Destructor]
}

//==============================================================================
void Window::paint (Graphics& g)
{
    g.fillAll (Colours::lightblue);

    //[UserPaint] Add your own custom paint stuff here..
    //[/UserPaint]
}

void Window::resized()
{
    drawingPanel->setBounds (16, 40, getWidth () - 30, getHeight () - 54);
    prevFrame->setBounds (16, 8, 24, 24);
    currentFrame->setBounds (40, 8, 48, 24);
    nextFrame->setBounds (88, 8, 24, 24);
    store->setBounds (120, 8, 56, 24);
    play->setBounds (getWidth() - 68, 8, 56, 24);
    lengthLabel->setBounds (186, 8, 120, 24);
    length->setBounds (304, 8, 48, 24);
    colour1->setBounds (418, 8, 32, 24);
    colour2->setBounds (450, 8, 32, 24);
    colour3->setBounds (482, 8, 32, 24);
    colour4->setBounds (514, 8, 32, 24);
    coloursLabel->setBounds (360, 8, 64, 24);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}

void Window::buttonClicked (Button* buttonThatWasClicked)
{
    if (buttonThatWasClicked == prevFrame)
    {
        //[UserButtonCode_prevFrame] -- add your button handler code here..
		String tempstr;

		currentTime -= 1.0f;
		if(currentTime < 0.0f)
			currentTime = 0.0f;

		tempstr.printf(T("%4.2f"), currentTime);
		currentFrame->setText(tempstr);

		drawingPanel->setTime(currentTime/currentLength);
        //[/UserButtonCode_prevFrame]
    }
    else if (buttonThatWasClicked == nextFrame)
    {
        //[UserButtonCode_nextFrame] -- add your button handler code here..
		String tempstr;

		currentTime += 1.0f;
		if(currentTime > currentLength)
			currentTime = currentLength;

		tempstr.printf(T("%4.2f"), currentTime);
		currentFrame->setText(tempstr);

		drawingPanel->setTime(currentTime/currentLength);
        //[/UserButtonCode_nextFrame]
    }
    else if (buttonThatWasClicked == store)
    {
        //[UserButtonCode_store] -- add your button handler code here..

		AlertWindow al(T("Store Frame..."),
					   T("Select polygons to store at the current time:"),
					   AlertWindow::NoIcon);
		ToggleButton t1(T("Store Polygon 1"));
		t1.setSize(150, 24);
		t1.setToggleState(lastSelectedPolys[0], false);
		t1.setWantsKeyboardFocus(false);
		ToggleButton t2(T("Store Polygon 2"));
		t2.setSize(150, 24);
		t2.setToggleState(lastSelectedPolys[1], false);
		t2.setWantsKeyboardFocus(false);
		ToggleButton t3(T("Store Polygon 3"));
		t3.setSize(150, 24);
		t3.setToggleState(lastSelectedPolys[2], false);
		t3.setWantsKeyboardFocus(false);
		ToggleButton t4(T("Store Polygon 4"));
		t4.setSize(150, 24);
		t4.setToggleState(lastSelectedPolys[3], false);
		t4.setWantsKeyboardFocus(false);

		al.addCustomComponent(&t1);
		al.addCustomComponent(&t2);
		al.addCustomComponent(&t3);
		al.addCustomComponent(&t4);
		al.addButton(T("Cancel"), 0, KeyPress(KeyPress::escapeKey));
		al.addButton(T("Ok"), 1, KeyPress(KeyPress::returnKey));

		//Stupid fix to make sure only the Ok button responds to the return key.
		al.getChildComponent(4)->setWantsKeyboardFocus(false);
		al.getChildComponent(5)->grabKeyboardFocus();

		if(al.runModalLoop())
		{
			//Update lastSelectedPolys.
			lastSelectedPolys[0] = t1.getToggleState();
			lastSelectedPolys[1] = t2.getToggleState();
			lastSelectedPolys[2] = t3.getToggleState();
			lastSelectedPolys[3] = t4.getToggleState();

			//Store positions of the selected polygons.
			for(int i=0;i<4;++i)
			{
				if(lastSelectedPolys[i])
					drawingPanel->storePoly(i);
			}
		}

        //[/UserButtonCode_store]
    }
    else if (buttonThatWasClicked == play)
    {
        //[UserButtonCode_play] -- add your button handler code here..
		if(play->getButtonText() == T("Play"))
		{
			drawingPanel->startAnimation();
			play->setButtonText(T("Stop"));
			play->setColour(TextButton::buttonColourId, Colours::yellow);
		}
		else
		{
			drawingPanel->stopAnimation();
			play->setButtonText(T("Play"));
			play->setColour(TextButton::buttonColourId, Colour(0xff20941d));
		}
        //[/UserButtonCode_play]
    }
    else if (buttonThatWasClicked == colour1)
    {
        //[UserButtonCode_colour1] -- add your button handler code here..
		ColourChooser col(this, 0);
		Colour tempCol = colour1->findColour(TextButton::buttonColourId);

		DialogWindow::showModalDialog(T("Select colour 1..."),
									  &col,
									  this,
									  Colours::lightblue,
									  false,
									  true,
									  true);
		if(!col.isOkay())
		{
			colour1->setColour(TextButton::buttonColourId, tempCol);
			drawingPanel->setPolygonColour(0, tempCol);
		}
        //[/UserButtonCode_colour1]
    }
    else if (buttonThatWasClicked == colour2)
    {
        //[UserButtonCode_colour2] -- add your button handler code here..
		ColourChooser col(this, 1);
		Colour tempCol = colour2->findColour(TextButton::buttonColourId);

		DialogWindow::showModalDialog(T("Select colour 2..."),
									  &col,
									  this,
									  Colours::lightblue,
									  false,
									  true,
									  true);
		if(!col.isOkay())
		{
			colour2->setColour(TextButton::buttonColourId, tempCol);
			drawingPanel->setPolygonColour(1, tempCol);
		}
        //[/UserButtonCode_colour2]
    }
    else if (buttonThatWasClicked == colour3)
    {
        //[UserButtonCode_colour3] -- add your button handler code here..
		ColourChooser col(this, 2);
		Colour tempCol = colour3->findColour(TextButton::buttonColourId);

		DialogWindow::showModalDialog(T("Select colour 3..."),
									  &col,
									  this,
									  Colours::lightblue,
									  false,
									  true,
									  true);
		if(!col.isOkay())
		{
			colour3->setColour(TextButton::buttonColourId, tempCol);
			drawingPanel->setPolygonColour(2, tempCol);
		}
        //[/UserButtonCode_colour3]
    }
    else if (buttonThatWasClicked == colour4)
    {
        //[UserButtonCode_colour4] -- add your button handler code here..
		ColourChooser col(this, 3);
		Colour tempCol = colour4->findColour(TextButton::buttonColourId);

		DialogWindow::showModalDialog(T("Select colour 4..."),
									  &col,
									  this,
									  Colours::lightblue,
									  false,
									  true,
									  true);
		if(!col.isOkay())
		{
			colour4->setColour(TextButton::buttonColourId, tempCol);
			drawingPanel->setPolygonColour(3, tempCol);
		}
        //[/UserButtonCode_colour4]
    }
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...

const StringArray Window::getMenuBarNames(MenuBarComponent* menuBar)
{
	StringArray retval;

	retval.add(T("File"));
	//retval.add(T("View"));
	retval.add(T("Help"));

	return retval;
}

const PopupMenu Window::getMenuForIndex(MenuBarComponent *menuBar,
										  int topLevelMenuIndex,
										  const String& menuName)
{
	PopupMenu retval;

	if(menuName == T("File"))
	{
		retval.addItem(FileNew, T("New"));
		retval.addSeparator();
		retval.addItem(FileOpen, T("Open"));
		retval.addSeparator();
		retval.addItem(FileSave, T("Save"));
		retval.addItem(FileSaveAs, T("Save as"));
		retval.addSeparator();
		retval.addItem(FileQuit, T("Quit"));
	}
	/*else if(menuName == T("View"))
	{
		retval.addItem(ViewHeilan, T("View in Heilan"));
		retval.addItem(ViewOptions, T("Heilan options"));
	}*/
	else if(menuName == T("Help"))
	{
		retval.addItem(HelpAbout, T("About"));
	}

	return retval;
}

void Window::menuItemSelected(MenuBarComponent *menuBar,
							  int menuItemID,
							  int topLevelMenuIndex)
{
	String tempstr;

	switch(menuItemID)
	{
		case FileNew:
			drawingPanel->clear();
			drawingPanel->repaint();
			colour1->setColour(TextButton::buttonColourId,
							   drawingPanel->getPolygonColour(0));
			colour2->setColour(TextButton::buttonColourId,
							   drawingPanel->getPolygonColour(1));
			colour3->setColour(TextButton::buttonColourId,
							   drawingPanel->getPolygonColour(2));
			colour4->setColour(TextButton::buttonColourId,
							   drawingPanel->getPolygonColour(3));
			fileLoader->setFile(File(T("")));
			break;
		case FileOpen:
			fileLoader->loadFromUserSpecifiedFile(true);
			break;
		case FileSave:
			fileLoader->save(true, true);
			break;
		case FileSaveAs:
			fileLoader->saveAsInteractive(true);
			break;
		case FileQuit:
			JUCEApplication::quit();
			break;
		/*case ViewHeilan:

			break;
		case ViewOptions:

			break;*/
		case HelpAbout:
			{
				AboutBox about;

				DialogWindow::showModalDialog(T("About"),
											  &about,
											  this,
											  Colours::lightblue,
											  false);
			}
			break;
	}
}

void Window::textEditorTextChanged(TextEditor& editor)
{
	if(&editor == currentFrame)
	{
		String tempstr;

		tempstr = currentFrame->getText();
		currentTime = tempstr.getFloatValue();
		if(currentTime < 0.0f)
			currentTime = 0.0f;
		else if(currentTime > currentLength)
			currentTime = currentLength;

		drawingPanel->setTime(currentTime/currentLength);
	}
	else if(&editor == length)
	{
		String tempstr;

		tempstr = length->getText();
		currentLength = tempstr.getFloatValue();

		drawingPanel->setLength(currentLength);
	}
}

void Window::changeListenerCallback(void *object)
{
	stringstream tempstr;
	float tempf = (drawingPanel->getTime() * currentLength);

	//Have to use stringstream because JUCE::String doesn't have any facility to
	//limit the number of digits after the decimal point.
	if(tempf < 0.1f)
		tempstr << setprecision(1) << tempf;
	else if(tempf < 1.0f)
		tempstr << setprecision(2) << tempf;
	else if(tempf < 10.0f)
		tempstr << setprecision(3) << tempf;
	else if(tempf < 100.0f)
		tempstr << setprecision(4) << tempf;
	else if(tempf < 1000.0f)
		tempstr << setprecision(5) << tempf;
	else
		tempstr << setprecision(6) << tempf;
	currentTime = tempf;

	currentFrame->setText(tempstr.str().c_str(), false);
}

void Window::setPolygonColour(int index, const Colour& colour)
{
	switch(index)
	{
		case 0:
			colour1->setColour(TextButton::buttonColourId, colour);
			drawingPanel->setPolygonColour(index, colour);
			break;
		case 1:
			colour2->setColour(TextButton::buttonColourId, colour);
			drawingPanel->setPolygonColour(index, colour);
			break;
		case 2:
			colour3->setColour(TextButton::buttonColourId, colour);
			drawingPanel->setPolygonColour(index, colour);
			break;
		case 3:
			colour4->setColour(TextButton::buttonColourId, colour);
			drawingPanel->setPolygonColour(index, colour);
			break;
	}
}

Colour Window::getPolygonColour(int index) const
{
	Colour retval;

	switch(index)
	{
		case 0:
			retval = colour1->findColour(TextButton::buttonColourId);
			break;
		case 1:
			retval = colour2->findColour(TextButton::buttonColourId);
			break;
		case 2:
			retval = colour3->findColour(TextButton::buttonColourId);
			break;
		case 3:
			retval = colour4->findColour(TextButton::buttonColourId);
			break;
	}

	return retval;
}

void Window::setPolygonList(int index, const list<Polygon>& polysList)
{
	drawingPanel->setPolygonList(index, polysList);
	drawingPanel->repaint();
}

const list<Polygon>& Window::getPolygonList(int index) const
{
	return drawingPanel->getPolygonList(index);
}

void Window::setLength(float val)
{
	String tempstr;

	drawingPanel->setLength(val);

	tempstr << val;
	length->setText(tempstr);
}

float Window::getLength() const
{
	return drawingPanel->getLength();
}

//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="Window" componentName=""
                 parentClasses="public Component, public MenuBarModel, public TextEditorListener, public ChangeListener"
                 constructorParams="" variableInitialisers="" snapPixels="8" snapActive="1"
                 snapShown="1" overlayOpacity="0.330000013" fixedSize="0" initialWidth="800"
                 initialHeight="620">
  <BACKGROUND backgroundColour="ffadd8e6"/>
  <GENERICCOMPONENT name="drawingPanel" memberName="drawingPanel" pos="16 40 30M 54M"
                    class="DrawingPanel" params=""/>
  <TEXTBUTTON name="prevFrame" memberName="prevFrame" pos="16 8 24 24" bgColOff="ffadd8e6"
              buttonText="&lt;" connectedEdges="2" needsCallback="1"/>
  <TEXTEDITOR name="currentFrame" memberName="currentFrame" pos="40 8 48 24"
              initialText="0.00" multiline="0" retKeyStartsLine="0" readonly="0"
              scrollbars="1" caret="1" popupmenu="1"/>
  <TEXTBUTTON name="nextFrame" memberName="nextFrame" pos="88 8 24 24" bgColOff="ffadd8e6"
              buttonText="&gt;" connectedEdges="1" needsCallback="1"/>
  <TEXTBUTTON name="store" memberName="store" pos="120 8 56 24" bgColOff="ffff2e2e"
              bgColOn="ffff0000" buttonText="Store" connectedEdges="0" needsCallback="1"/>
  <TEXTBUTTON name="play" memberName="play" pos="68R 8 56 24" bgColOff="ff20941d"
              bgColOn="ff2fb200" buttonText="Play" connectedEdges="0" needsCallback="1"/>
  <LABEL name="lengthLabel" memberName="lengthLabel" pos="186 8 120 24"
         bkgCol="0" textCol="ff000000" outlineCol="0" edTextCol="ff000000"
         edBkgCol="0" labelText="Length (seconds):" editableSingleClick="0"
         editableDoubleClick="0" focusDiscardsChanges="0" fontname="Default font"
         fontsize="15" bold="0" italic="0" justification="33"/>
  <TEXTEDITOR name="length" memberName="length" pos="304 8 48 24" initialText="180"
              multiline="0" retKeyStartsLine="0" readonly="0" scrollbars="1"
              caret="1" popupmenu="1"/>
  <TEXTBUTTON name="colour1" memberName="colour1" pos="418 8 32 24" bgColOff="ffadd8e6"
              buttonText="1" connectedEdges="2" needsCallback="1"/>
  <TEXTBUTTON name="colour2" memberName="colour2" pos="450 8 32 24" bgColOff="ffadd8e6"
              buttonText="2" connectedEdges="3" needsCallback="1"/>
  <TEXTBUTTON name="colour3" memberName="colour3" pos="482 8 32 24" bgColOff="ffadd8e6"
              buttonText="3" connectedEdges="3" needsCallback="1"/>
  <TEXTBUTTON name="colour4" memberName="colour4" pos="514 8 32 24" bgColOff="ffadd8e6"
              buttonText="4" connectedEdges="1" needsCallback="1"/>
  <LABEL name="coloursLabel" memberName="coloursLabel" pos="360 8 64 24"
         bkgCol="0" textCol="ff000000" outlineCol="0" edTextCol="ff000000"
         edBkgCol="0" labelText="Colours:" editableSingleClick="0" editableDoubleClick="0"
         focusDiscardsChanges="0" fontname="Default font" fontsize="15"
         bold="0" italic="0" justification="33"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif


